#!/usr/bin/ruby
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'rubygems'
require 'active_record'

ActiveRecord::Base.establish_connection(
  :adapter => 'mysql',
  :host => '127.0.0.1',
  :database => 'webshop'
)



class Flower < ActiveRecord::Base; end



class Flower < ActiveRecord::Base
  def to_s
    "A #{self.name} (#{self.id}) costs $#{self.price}."
  end
end



flower = Flower.new
flower.name = 'primrose'
flower.price = 0.99



[
  ['rose', 1.10],
  ['violet', 0.40],
  ['sunflower', 0.40],
  ['clove', 0.65],
  ['lily', 0.80]
].each do |name, price|
  flower = Flower.new(:name => name, :price => price)
  flower.save
end



Flower.find(:all).each do |f|
  puts "A #{f.name} costs $#{f.price}."
end


puts "find_by_name"

rose = Flower.find_by_name('rose')

puts rose

puts "find_all_by_price"

Flower.find_all_by_price(0.4).each { |f| puts f }


puts "find_by_name_and_price"

clove = Flower.find_by_name_and_price('clove', 0.65)

puts clove

puts "find_with_condition"

cheap = Flower.find(:all, :conditions => ['price < 0.8'])
cheap.each { |f| puts f }


puts "find_with_condition_safe"

cheap = Flower.find(:all, :conditions => ['price < ?', 0.8])
cheap.each { |f| puts f }



sunflower = Flower.find_by_name('sunflower')
sunflower.destroy


Flower.find(:all).each { |f| f.destroy }
# vim:sw=2:tw=0

