#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'

require 'singleton'
require 'mysql'

class Database
  include Singleton
  attr_reader :connection

  def initialize() @connection = nil; end
  
  def connect(host, usr, pwd, db= nil)
    @connection = Mysql.new(host, usr, pwd, db)
  end

  def disconnect
    @connection.close if !@connection.nil?
    @connection = nil
  end
end



class Flower
  attr_reader :id
  attr_accessor :name, :price
  
  def Flower.create(name, price)
    Database.instance.connection.query(<<-SQL)
    insert into flowers (name, price)
    values ('#{name}', #{price.to_f})
    SQL
    Flower.new(
      Database.instance.connection.insert_id,
      name,
      price
    )
  end

  def to_s
    "A #{@name} (#{@id}) costs $#{@price}."
  end
  
  private

  def initialize(id, name, price)
    @id, @name, @price = id, name, price
  end
end



class Flower
  def Flower.find(name)
    flower = Database.instance.connection.query(<<-SQL)
    select id, name, price from flowers where name ='#{name}'
    SQL
    return nil if flower.num_rows == 0
    attr = flower.fetch_hash
    Flower.new(attr['id'], attr['name'], attr['price'])
  end

  def update
    Database.instance.connection.query(<<-SQL)
    update flowers set name = '#{@name}', price = '#{@price}'
    where id = #{@id}
    SQL
  end

  def destroy
    Database.instance.connection.query(<<-SQL)
    delete from flowers where id = #{@id}
    SQL
  end
end


if $0 == __FILE__
  
  Database.instance.connect('localhost', '', '', 'webshop')
  rose = Flower.create('rose', 1.99)
  puts rose
  

  
  rose = Flower.find('rose')
  rose.price = 2.49
  rose.update

  rose = Flower.find('rose')
  puts rose
  rose.destroy
  puts Flower.find('rose')
  Database.instance.disconnect
  
end
# vim:sw=2:tw=0

