#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'
require 'active_record'

ActiveRecord::Base.establish_connection(
  :adapter => 'mysql',
  :host => '127.0.0.1',
  :database => 'webshop'
)



class Bouquet < ActiveRecord::Base
  has_and_belongs_to_many :flowers
end

class Flower < ActiveRecord::Base
  has_and_belongs_to_many :bouquets
end


Flower.find(:all).each { |f| f.destroy }

[
  ['rose', 1.10],
  ['violet', 0.40],
  ['sunflower', 0.40],
  ['clove', 0.65],
  ['lily', 0.80]
].each do |name, price|
  flower = Flower.new(:name => name, :price => price)
  flower.save
end


rose = Flower.find_by_name('rose')
bouquet = Bouquet.new
bouquet.name = 'Red Dream'
bouquet.base_price = 2.49;
bouquet.save
6.times { bouquet.flowers << rose } 
bouquet.flowers << Flower.find_by_name('sunflower')



b = Bouquet.find_by_name('Red Dream')
puts "'#{b.name}' contains #{b.flowers.size} flowers:"
b.flowers.each { |f| puts f.name }


b.destroy
exit

# vim:sw=2:tw=0
