#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'
require 'active_record'

ActiveRecord::Base.establish_connection(
  :adapter => 'mysql',
  :host => '127.0.0.1',
  :database => 'webshop'
)


class Flower < ActiveRecord::Base; end


class AddLifeTime < ActiveRecord::Migration
  def self.up
    add_column :flowers, :life_time, :integer, :default => 5
    Flower.reset_column_information 
    Flower.find(:all).each do |f| 
      f.life_time = 3
      f.save!
    end
  end

  def self.down
    remove_column :flowers, :life_time
  end
end


if __FILE__ == $0
  
  [
    ['rose', 1.10],
    ['sunflower', 0.40],
    ['lily', 0.80]
  ].each do |name, price|
    flower = Flower.new(
      :name => name,
      :price => price
    )
    flower.save!
  end

  AddLifeTime.up
  Flower.reset_column_information

  Flower.find(:all).each do |f|
    puts "A #{f.name} costs $#{f.price} and lives " +
      "for #{f.life_time} days."
  end
  
end
