#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'cusfinder'
require 'whitelist'

# Read all potential customers
ora_connection = OCI8.new('maik', 'maik')
finder = CustomerFinder.new(ora_connection)
customers = finder.find(180)
ora_connection.logoff

# Sort out customers not in whitelist
mysql_connection = Mysql.new('localhost', '', '', 'webshop')
whitelist = Whitelist.new(mysql_connection)

customers.each do |c| 
  puts c.to_csv if whitelist.contains?(c.email)
end
mysql_connection.close

# vim:sw=2:tw=0
