#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'cusfinder'
require 'whitelist'
require 'recipient'

# Read all potential customers
ora_connection = OCI8.new('maik', 'maik')
ora_connection.autocommit = true
recipients = Recipient.new(ora_connection)
finder = CustomerFinder.new(ora_connection)
customers = finder.find(180)

# Sort out customers not in whitelist
mysql_connection = Mysql.new('localhost', '', '', 'webshop')
whitelist = Whitelist.new(mysql_connection)

customers.each do |c| 
  if whitelist.contains?(c.email)
     puts c.to_csv
     recipients.create(c)
  end
end

ora_connection.logoff
mysql_connection.close

# vim:sw=2:tw=0
