#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'oci8'

connection = OCI8.new('maik', 'maik')
sql = <<-SQL
# STOP_SYNTAX
select a.id, a.name, a.surname, a.email
from   customers a, orders b
where  a.id = b.customer_id
and    b.created < sysdate - 180
and    b.created = (
  select max(created)
  from   orders
  where  customer_id = a.id
)
SQL

# START_SYNTAX

num_customers = connection.exec(sql) do |row|
  puts row[3]
end


puts "Found #{num_customers} coupon recipients."
connection.logoff


# vim:sw=2:tw=0
