#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'
require 'activeldap'

ActiveLDAP::Base.connect(
  :base => 'dc=pragbouquet,dc=com',
  :bind_format => 'cn=root,dc=pragbouquet,dc=com',
  :password_block => Proc.new { 'secret' },
  :allow_anonymous => false
)


class Group < ActiveLDAP::Base
  ldap_mapping :dnattr => 'cn', :prefix => 'ou=Groups'
end


class Customer < ActiveLDAP::Base
  ldap_mapping :dnattr => 'uid',
               :prefix => 'cn=customers,ou=Groups'

  belongs_to :groups, 
             :class_name => 'Group',
             :foreign_key => 'gidNumber',
             :local_key => 'gidNumber'
end

h = Customer.new('homer@example.com')
h.groups.each { |g| puts g.cn }

