#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'
require 'activeldap'

ActiveLDAP::Base.connect(
  :base => 'dc=pragbouquet,dc=com',
  :bind_format => 'cn=root,dc=pragbouquet,dc=com',
  :password_block => Proc.new { 'secret' },
  :allow_anonymous => false
)



class Group < ActiveLDAP::Base
  ldap_mapping :dnattr => 'cn', :prefix => 'ou=Groups'
  has_many :members,
           :class_name => 'Employee',
           :local_key => 'gidNumber',
           :foreign_key => 'gidNumber'
end

class Employee < ActiveLDAP::Base
  ldap_mapping :dnattr => 'uid',
               :prefix => 'cn=employees,ou=Groups'
end

employees = Group.new('employees')
employees.members.each { |e| puts e.cn }

