#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'ldap'
include LDAP

User = Struct.new(:uid, :name, :surname)
user = User.new('23', 'Jane', 'Doe')
full_name = user.name + ' ' + user.surname

connection = Conn.new
connection.set_option(LDAP_OPT_PROTOCOL_VERSION, 3)
connection.bind('cn=root,dc=pragbouquet,dc=com', 'secret') do
  entry = [
    LDAP.mod(LDAP_MOD_ADD, 'objectclass', %w(top person uidObject)),
    LDAP.mod(LDAP_MOD_ADD, 'uid', [user.uid]),
    LDAP.mod(LDAP_MOD_ADD, 'cn', [full_name]),
    LDAP.mod(LDAP_MOD_ADD, 'sn', [user.surname]),
    LDAP.mod(LDAP_MOD_ADD, 'description', ['Address book of ' + full_name])
  ]

  begin
    connection.add('uid=' + user.uid + ',dc=pragbouquet,dc=com', entry)
  rescue Exception => ex
    puts ex
  end
end
