#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'pp'
require 'ldap'
include LDAP

begin
  connection = Conn.new('127.0.0.1', LDAP_PORT)
  connection.set_option(LDAP_OPT_PROTOCOL_VERSION, 3)
  connection.bind do 
    base_dn = 'uid=4711,dc=pragbouquet,dc=com'
    scope = LDAP_SCOPE_ONELEVEL
    filter = '(objectClass=*)'
    connection.search(base_dn, scope, filter) do |entry|
      pp entry.to_hash 
    end
  end
rescue Exception => ex
  puts ex
end
