create table countries(
  country_code varchar(2) primary key,
  name varchar(128) not null
);

create table customers(
  id int not null auto_increment primary key,
  name varchar(64) not null,
  surname varchar(128) not null,
  street varchar(128) not null,
  house_number varchar(10) not null,
  postal_code varchar(10) not null,
  city varchar(128) not null,
  state varchar(20),
  country_code varchar(2) not null,
  email varchar(128) not null,
  created timestamp
);
alter table customers add constraint fk_customer
  foreign key (country_code) references countries(country_code);

-- START:fill_countries
insert into countries values('US', 'United States');
insert into countries values('DE', 'Germany');
insert into countries values('IT', 'Italy');
insert into countries values('FR', 'France');
insert into countries values('GB', 'United Kingdom');
-- END:fill_countries

-- START:fill_customers
insert into customers values(
  null,
  'Homer',
  'Simpson',
  'Evergreen Terace',
  '42',
  '1111',
  'Springfield',
  'xx',
  'US',
  'homer@example.com',
  null
);
-- END:fill_customers

-- START:create_example
create table orders(
  id int not null auto_increment primary key,
  customer_id int not null,
  status enum('open', 'cancelled', 'delivered') not null,
  created timestamp
);
alter table orders add constraint fk_order
  foreign key (customer_id) references customers(id);

create table order_items(
  id int not null auto_increment primary key,
  order_id int not null,
  item varchar(100) not null,
  amount int not null
);
alter table order_items add constraint fk_order_item
  foreign key (order_id) references orders(id);
-- END:create_example

-- START:fill_orders
-- Order from customer #1
insert into orders values (1, 1, 'open', null);
insert into order_items values(null, 1, 'foo', 5);
insert into order_items values(null, 1, 'bar', 3);

-- Order from customer #2
insert into orders values (2, 1, 'open', null);
insert into order_items values(null, 2, 'acme roller blades', 1);
-- END:fill_orders
