#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'oci8'
require 'singleton'

class Database
  include Singleton

  attr_reader :connection
  
  def initialize
    @connection = nil
  end
  
  def connect(usr, pwd, dbname = nil)
    @connection = OCI8.new(usr, pwd, dbname)
    @connection.autocommit = true
    @connection
  end

  def disconnect
    if !@connection.nil?
      @connection.logoff
      @connection = nil
    end
  end
end


class Database
  def exec(sql, *bindvars)
    @connection.exec(sql, bindvars)
  end

  def prepare(sql)
    @connection.parse(sql)
  end
end

# vim:sw=2:tw=0
