#!/usr/bin/perl -w

use strict;
use DBI;

sub get_flowers {
  my $result = [];
  my $dbh = DBI->connect('dbi:mysql:webshop', '', '');

  my $sql = qq{ SELECT name, price FROM flowers };
  my $sth = $dbh->prepare($sql);
  $sth->execute();
  my ($name, $price);
  $sth->bind_columns( undef, \$name, \$price );

  while($sth->fetch()) {
	push(@$result, [$name, $price]);
  }

  $sth->finish();
  $dbh->disconnect();
  return $result;
}

print "status: 200\r\n"; # <label id="code.report.status"/>
print "content-type: text/xml\r\n\r\n";

print "<?xml version='1.0'?>\r\n";
print "<flowers>\r\n";
my $flowers = get_flowers();
for (@$flowers) {
  print "  <flower name='$_->[0]' price='$_->[1]'/>\r\n";
}
print "</flowers>\r\n";
