/***
 * Excerpted from "Enterprise Integration with Ruby"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
***/
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import sms.*;

public class SmsServer {
   public static void main(final String args[]) {
      try {
         final ORB orb = ORB.init(args, null);
         final POA rootpoa = POAHelper.narrow(
            orb.resolve_initial_references("RootPOA")
         );
         rootpoa.the_POAManager().activate();
         
         final org.omg.CORBA.Object ref =
            rootpoa.servant_to_reference(new SmsServiceImpl());
         final org.omg.CORBA.Object objRef =
            orb.resolve_initial_references("NameService");
            
         final NamingContextExt ncRef =
            NamingContextExtHelper.narrow(objRef);
         final NameComponent path[] =
            ncRef.to_name("SmsService");            
         ncRef.rebind(path, SmsServiceHelper.narrow(ref));
         
         System.out.println("SMS server is starting ...");
         orb.run();
      } 
      catch(Exception e) {
         System.err.println("An exception occurred: " + e);
         e.printStackTrace(System.err);
      }
   }
}
