/***
 * Excerpted from "Enterprise Integration with Ruby"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
***/
import sms.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class SmsServiceClient {
   public SmsServiceClient() throws Exception {
      this("localhost", 1050);
   }

   public SmsServiceClient(
      final String host,
      final int    port) throws Exception
   {
      _smsService = getSmsService(host, port);
   }

   public short sendTextSms(
      final String recipient,
      final String sender,
      final String data) throws IOError
   {
      return _smsService.send_text(recipient, sender, data);
   }

   public short sendBinarySms(
      final String recipient,
      final String sender,
      final String data) throws IOError
   {
      return _smsService.send_binary(recipient, sender, data);
   }

   private SmsService getSmsService(
      final String host,
      final int port) throws Exception
   {
      final String[] args = new String[] {
         "-ORBInitialHost", host,
         "-ORBInitialPort", "" + port
      };
      final ORB orb = ORB.init(args, null);
      
      final org.omg.CORBA.Object objRef =
         orb.resolve_initial_references("NameService");
      final NamingContextExt ncRef =
         NamingContextExtHelper.narrow(objRef);
         
      final String name = "SmsService";
      return SmsServiceHelper.narrow(ncRef.resolve_str(name));
   }

   private final SmsService _smsService;
}
