/***
 * Excerpted from "Enterprise Integration with Ruby"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
***/
import sms.*;

class SmsServiceImpl extends SmsServicePOA {
   public short send_text(
      final String recipient,
      final String sender,
      final String data) throws IOError
   {
      // Send SMS somehow...
      final short text_length = (short)data.length();
      final short bit_amount = (short)(text_length * 7);
      short byte_amount = (short)(bit_amount / 8);
      if (bit_amount % 8 != 0)
         byte_amount++;
      return byte_amount;
   }
    
   public short send_binary(
      final String recipient,
      final String sender,
      final String data) throws IOError
   {
      if (data.length() % 2 != 0)
        throw new IOError("Odd length of binary data!");
                
      // Send SMS somehow...
      return (short)(data.length() / 2);
   }
}
