#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'rjb'
require 'webrick'
include WEBrick

Rjb::load
sms_service_client_class = Rjb::import('SmsServiceClient')
sms_service = sms_service_client_class.new('localhost', 1050)

sms_server = HTTPServer.new(:Port => 4242)
sms_server.mount_proc('/send') do |req, res|
   type = req.query['type'] || 'text'
   recipient = req.query['recipient']
   sender = req.query['sender'] || recipient
   data = req.query['data']

   res['Content-Type'] = 'text/plain'
   res.status = 200 
   res.body = 'Message was sent successfully.'
   method = type == 'binary' ? 'sendBinarySms' : 'sendTextSms'
   begin
      sms_service.send(method, recipient, sender, data)
   rescue IOError => ex
      res.status = 500
      res.body = 'Message could not be sent.'
   end
end

trap("INT") { sms_server.shutdown }
sms_server.start
