#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'drb'
require 'sequence'

class SequenceManager
  def initialize
    @sequences = {}
    @mutex = Mutex.new
  end
  
  def create(name, start_value, step)
    @mutex.synchronize do
      if !@sequences.has_key?(name)
        @sequences[name] = Sequence.new(start_value, step)
      end
    end
    @sequences[name]
  end
  
  def get(name)
    @sequences[name]
  end
end
  
DRb.start_service('druby://localhost:9000', SequenceManager.new)
DRb.thread.join
