#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'rjb'

#Rjb::load

def line(title) puts "\n", title + '-' * 30, "\n"; end
    
str = Rjb::import('java.lang.String')
puts str.class

instance = str.new_with_sig('Ljava.lang.String;', 'Hello, world!')
puts instance.length()
puts instance.toString()
puts instance._classname
#Rjb::unload

line('_classname')


str = Rjb::import('java.lang.String')
instance = str.new('Hello, world!')
puts instance._classname



flower = Rjb::import('com.pragbouquet.Flower')
f = flower.new('rose', 2.49)
puts "A #{f.getName()} costs $#{f.getPrice()}."



flower = Rjb::import('com.pragbouquet.Flower')
f = flower.new_with_sig('Ljava.lang.String;D', 'rose', 2.49)
puts "A #{f.getName()} costs $#{f.getPrice()}."



class FileFilter
  def accept(file)
    !(file.toString =~ /\.java$/).nil?
  end
end

filter = FileFilter.new
filter = Rjb::bind(filter, 'java.io.FileFilter')
java_file = Rjb::import('java.io.File')
jf = java_file.new('.')
jf.listFiles(filter).each { |f| puts f.toString }

