#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'test/unit'
require 'stringio'
require 'status_monitor'

class StatusMonitorTest < Test::Unit::TestCase
   def setup
      @server = StatusMonitor.new
   end
   
   def test_empty_string
      result = simulate_request("\n")
      assert_equal('1', result)
   end
   
   def test_invalid_level
      result = simulate_request("x,foo,invalid level\n")
      assert_equal('1', result)
   end
   
   def test_normal_case
      result = simulate_request("e,foo,normal case\n")
      assert_equal('0', result)
   end

   def simulate_request(request)
      client = StringIO.new(request)
      @server.serve(client)
      client.string[request.size - 2 .. -2] 
   end
end
