#!/usr/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'webrick'
include WEBrick

sms = HTTPServer.new(:Port => 4242)
sms.mount_proc("/send") do |req, res|
   type = req.query['type'] || 'text'
   recipient = req.query['recipient']
   sender = req.query['sender'] || recipient
   data = req.query['data']

   puts type, recipient, sender, data
   res['Content-Type'] = "text/plain"
   if type == 'binary'
      res.status = 500 
      res.body = 'Binary messages cannot be transmitted, currently.'
   else
      res.status = 200 
      res.body = 'Message was sent successfully.'
   end
end

trap("INT") { sms.shutdown }
sms.start
