#!/usr/bin/perl -w

#START:main
package StatusMonitor;

use strict;
use IO::Socket;

use constant WARN => 'w';
use constant ERROR => 'e';
use constant FATAL => 'f';

sub new {
   my $class = shift;
   my ($host, $port) = @_;
   my $self = {};
   my $sm = IO::Socket::INET->new("$host:$port");
   die "Could not connect to status monitor: $!\n" unless $sm;
   $self->{'sm'} = $sm;
   bless $self, $class;
}

sub warn() {
   my ($self, $app, $msg) = @_;
   $self->_log(WARN, $app, $msg);
}

sub error() {
   my ($self, $app, $msg) = @_;
   $self->_log(ERROR, $app, $msg);
}

sub fatal() {
   my ($self, $app, $msg) = @_;
   $self->_log(FATAL, $app, $msg);
}

sub _log() {
   my ($self, $level, $app, $msg) = @_;
   my $sm = $self->{'sm'};
   $sm->print("$level,$app,$msg\n");
   $sm->getline;
}

sub DESTROY {
   close($_[0]->{'sm'});
}

1;
#END:main
