#!/usr/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'rubygems'
require 'active_record'
require 'gserver'

ActiveRecord::Base.establish_connection(
  :adapter => 'mysql',
  :host => '127.0.0.1',
  :database => 'smon'
)

class LogEntry < ActiveRecord::Base; end

class StatusMonitor < GServer
   def initialize(host = '127.0.0.1', port = '3333')
      super(port, host)
      @level_map = { 
         'w' => 'warn', 'e' => 'error', 'f' => 'fatal'
      }
   end
   
   # Expects CSV data in the following format:
   # level,application,message.
   def serve(client)
      level, app, msg = client.readline.chomp.split(',', 3)
      if @level_map.has_key?(level)
         entry = LogEntry.new
         entry.application = app
         entry.level = @level_map[level]
         entry.message = msg
         entry.save!
         client.puts('0')
      else
         client.puts('1')
      end
   end
end


sm = StatusMonitor.new
sm.start
sm.join
