#!/usr/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'
require 'active_record'

require 'webrick'


ActiveRecord::Base.establish_connection(
  :adapter => 'mysql',
  :host => '127.0.0.1',
  :database => 'smon'
)

class LogEntry < ActiveRecord::Base; end


include WEBrick
class StatusMonitorServlet < HTTPServlet::AbstractServlet
   
   # ...
   
   def do_GET(req, res)
      app = req.query['app']
      msg = req.query['msg']
      level = req.query['level'] || ''
      level.downcase!
      res['content-type'] = 'text/plain'
      if %w(debug info warn error fatal).include?(level)
         entry = LogEntry.new
         entry.application = app
         entry.level = level
         entry.message = msg
         entry.save!
         inform_helpdesk(app, level, msg) if level == 'fatal'
         res.status = 200 
         res.body = "Message was logged successfully."
      else
         res.status = 500 
         res.body = "An error occurred while logging message!"
      end
   end
   
   alias do_POST :do_GET 

   # ...
   

   
   private

   def inform_helpdesk(app, level, msg) end
   

end

server = HTTPServer.new(:Port => 4242) 
server.mount('/log', StatusMonitorServlet)

%w(INT TERM).each do |signal| 
   trap(signal) { server.shutdown } 
end 

server.start

