#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'digest/md5'

class Authenticator
  def initialize
    @users = {
      'scott' => 'tiger', 'maik' => 'secret'
    }
    @sessions = {}
  end

  def login(userid, password)
    userid and password and @users[userid] == password
  end

  def authenticate(sessionid)
    @sessions[sessionid] # -> userid
  end

  def create_session(userid)
    while true
      sessionid = create_sessionid
      break unless @sessions[sessionid]
    end
    @sessions[sessionid] = userid
    sessionid
  end

  def destroy_session(sessionid)
    @sessions.delete(sessionid)
  end

  private

  def create_sessionid
    Digest::MD5.hexdigest(Time.now.usec.to_s)
  end
end
