#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'authheader'

class ClientAuthHeaderHandler < AuthHeaderHandler
  def initialize(userid, passwd)
    super()
    @userid, @passwd = userid, passwd
    @sessionid, @mustunderstand = nil, true
  end
  def on_simple_outbound
    if @sessionid
      { 'sessionid' => @sessionid }
    else
      { 'userid' => @userid, 'passwd' => @passwd }
    end
  end
  def on_simple_inbound(auth_header, mustunderstand)
    @sessionid = auth_header['sessionid']
  end
end



require 'soap/rpc/driver'

namespace = 'http://pragbouquet.com/stockPort'
stock = SOAP::RPC::Driver.new('http://localhost:7000', namespace)
stock.add_method('get_report')
stock.add_method('create_flower', 'name', 'price', 'quantity')
stock.headerhandler << ClientAuthHeaderHandler.new( 
  'scott',
  'tiger'
)
stock.wiredump_dev = STDOUT
begin
  stock.create_flower('rose', 1.99, 1000)
  p stock.get_report
rescue Exception => ex
  puts ex
end

