#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'soap/rpc/driver'

stock = SOAP::RPC::Driver.new('http://localhost:2000', 'urn:Stock')
[ 
  %w(create_flower name price quantity),
  %w(add_flowers name quantity),
  %w(remove_flowers name quantity),
  %w(set_price name price),
  %w(get_report)
].each do |signature|
  stock.add_method(*signature)
end 

begin
  stock.create_flower('rose', 1.99, 1000)
  stock.create_flower('orchid', 3.14, 200)
  puts "Created 'rose' and 'orchid'."
  p stock.get_report

  stock.remove_flowers('rose', 5)
  puts 'Removed 5 roses.'
  p stock.get_report

  stock.add_flowers('orchid', 100)
  puts 'Added 100 orchids.'
  p stock.get_report

  stock.set_price('orchid', 3.01)
  puts 'Changed orchid price to $3.01.'
  p stock.get_report
rescue Exception => ex
  puts ex
end
