#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'soap/rpc/standaloneServer'
require 'stock'

class StockServer < SOAP::RPC::StandaloneServer
  def on_init
    @stock = Stock.new
    @log.level = Logger::Severity::DEBUG
    add_method(self, 'create_flower', 'name', 'price', 'quantity')
    add_method(self, 'add_flowers', 'name', 'quantity')
    add_method(self, 'remove_flowers', 'name', 'quantity')
    add_method(self, 'set_price', 'name', 'price')
    add_method(self, 'get_report')
  end

  def create_flower(name, price, quantity)
    @stock.create_flower(name, price, quantity)
  end
  
  def add_flowers(name, quantity)
    @stock.add_flowers(name, quantity)
  end
  
  def remove_flowers(name, quantity)
    @stock.remove_flowers(name, quantity)
  end
  
  def set_price(name, price)
    @stock.set_price(name, price)
  end
  
  def get_report
    @stock.get_report
  end
end

server = StockServer.new('stock', 'urn:Stock', '0.0.0.0', 2000) 
trap(:INT) { server.shutdown } 
server.start
