#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
Dir::chdir('code/dist_app/xml_rpc')


require 'webrick'
require 'xmlrpc/server'
require 'net/ftp'
require 'greeting_card'

s = XMLRPC::WEBrickServlet.new

s.add_handler('pragbouquet.draw_card') do |order_no, id, text|
   card = GreetingCard.create(order_no, id, text)
   {
      'cardref' => card.card_ref,
      'front' => XMLRPC::Base64.encode(card.front), 
      'back' => XMLRPC::Base64.encode(card.back) 
   }
end

s.add_handler('pragbouquet.print_card') do |cardref|
  # Transfer cardref.pdf to special directory, where
  # it gets picked up and is printed eventually
  ftp = Net::FTP.new('ftp.imagehost')
  ftp.login('imageserver', 'secret')
  files = ftp.chdir('pub/cards/img')
  ftp.putbinaryfile("#{cardref}.pdf")
  ftp.close
end

s.add_handler('pragbouquet.delete_card') do |cardref|
   File.delete("#{cardref}.pdf")
end

s.set_default_handler do |name, *args| 
  raise XMLRPC::FaultException.new(
    -100,
    "Method #{name} missing or wrong number of parameters!"
  )
end

server = WEBrick::HTTPServer.new(:Port => 8080)
server.mount('/RPC2', s)
trap('INT') { server.shutdown }

server.start

