#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'socket'

class StatusMonitorClient
  WARN = 'w'
  ERROR = 'e'
  FATAL = 'f'
   
  def initialize(host, port)
    @sm = TCPSocket.new(host, port)
  end
   
  def warn(app, msg) log(WARN, app, msg); end
  def error(app, msg) log(ERROR, app, msg); end
  def fatal(app, msg) log(FATAL, app, msg); end
   
  def terminate() @sm.close; end
   
  private
   
  def log(level, app, msg)
    @sm.puts [level, app, msg].join(',')
    @sm.readline
  end
end
