#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

class UString < String
  def length; self.unpack('U*').length end

  def reverse; self.scan(/./u).reverse.join end

  def inspect; "u#{super}" end
end

module Kernel
  def u(str)
    UString.new str.gsub(/U\+([0-9a-fA-F]{4})/u) {
      ["#$1".hex].pack('U*')
    }
  end
end 



str = u'Märchen'
puts str.length == 7
puts str.reverse == 'nehcräM'

str = u'MU+00fcnchen'
puts str
puts str.length

