#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'rubygems'
require 'log4r'
include Log4r


class ExceptionFormatter <  Log4r::Formatter
  def format(e)
     log = "[%5s] %s: %s\n" %
        [LNAMES[e.level], Time.now, e.data.to_s] 
     if e.data.class == Exception
        msg = e.data.message
        size = msg.size
        line = '!' * (size + 6) + "\n"
        log << line
        log << '! ' + msg.center(size + 2) + " !\n"
        log << line
     end
     log
  end
end

custom = Logger.new('my_first_format')
outputter = StdoutOutputter.new(
   'stdout',
   :formatter => ExceptionFormatter
)
custom.add(outputter)
custom.info(%w(cat mouse dog))
custom.fatal(Exception.new('ALAAARRRRMMM!'))
custom.error('I am so nicely formatted!')

