#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'rubygems'
require 'log4r'
include Log4r


class BufferedOutputter < IOOutputter
   def initialize(name, io, options = {})
     super(name, io, options)
     @out = io
     @last_events = []
     @max_events = options[:max_events] || 50
   end

   def canonical_log(event) 
      @last_events << event
      if @last_events.size >= @max_events ||
         LNAMES[event.level] == 'FATAL'
         @last_events.each { |e| super(e) }
         @last_events = []
      end
   end
end

logger = Logger.new('buffered-outputter')
outputter = BufferedOutputter.new(
   'buffered',
   $stdout,
   :max_events => 2
)
logger.outputters = outputter
logger.debug('I cannot be seen immediately!')
logger.info('Now both are there!')

