#!/usr/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'net/http'

class SmsService
   def initialize(host = '127.0.0.1', port = 4242)
     @host, @port = host, port
   end
   
   def send_text(params)
      send_sms(params, 'text')
   end
   
   def send_binary(params)
      send_sms(params, 'binary')
   end
   
   private


   def send_sms(params, type)
      result = false
      Net::HTTP.start(@host, @port) do |http|
         query = "type=#{type}"
         params.each { |k,v| query << "&#{k}=#{v}" }
         response = http.post(
            '/send',
            query,
            'content-type' => 'application/x-www-form-urlencoded'
         )
         result = response.class == Net::HTTPOK
      end
      result
   end

end

if $0 == __FILE__

   sms = SmsService.new
   sms.send_text(
     :recipient => '+0112341234567',
     :data => 'Hello, world!'
   )

end
