#!/usr/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'logger'
require 'gserver'

class StatusMonitor < GServer
   def initialize(host = '127.0.0.1', port = '3333')
      super(port, host)
      @level_map = { 
         'd' => 'debug', 'i' => 'info',
         'w' => 'warn',  'e' => 'error',
         'f' => 'fatal'
      }
      @logger = Logger.new(STDOUT)
   end
   
   # Expects CSV data in the following format:
   # level,application,message.
   def serve(client)
      level, app, msg = client.readline.chomp.split(',', 3)
      if @level_map.has_key?(level)
         @logger.send(@level_map[level], "#{app}: #{msg}")
         client.puts('0')
      else
         client.puts('1')
      end
   end
end

sm = StatusMonitor.new
sm.start
sm.join

