#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'getoptlong'
require 'test_tool'

tt_options = {
  :reference_dir => './reference',
  :create_reference => false,
  :output_dir => './output',
  :logfile => 'test_tool.log'
}

begin
  options = GetoptLong.new(
    ['--create-reference', '-c', GetoptLong::NO_ARGUMENT],
    ['--reference-dir', '-r', GetoptLong::OPTIONAL_ARGUMENT],
    ['--output-dir', '-o', GetoptLong::OPTIONAL_ARGUMENT],
    ['--logfile', '-l', GetoptLong::OPTIONAL_ARGUMENT]
  )


  options.each_option do |name, value|
    case name
    when '--create-reference'
      tt_options[:create_reference] = true
    when '--reference-dir'
      tt_options[:reference_dir] = value
    end
  end
rescue Exception => ex
  puts "#{File.basename($0)} usage: ..."
end

test_tool = TestTool.new(tt_options)
ARGV.each do |input_file|
  test_tool.process(input_file)
end

