#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'rubygems'
require 'builder'

doc = Builder::XmlMarkup.new
doc.person(:name => 'Max', :surname => 'Mustermann')
puts doc.target! 



xml = ''
doc = Builder::XmlMarkup.new(:target => xml) 
doc.person(:name => 'Max', :surname => 'Mustermann') { |person|
  person.address { |address|
    address.street('Hauptstr. 42')
  }
}
puts xml



xml = ''
doc = Builder::XmlMarkup.new(:target => xml, :indent => 2)
doc.person(:name => 'Max', :surname => 'Mustermann') { |person|
  person.address { |address|
    address.street('Hauptstr. 42')
    address.tag!('postal-code', '12345') 
    address.city('Musterstadt')
  }
}
puts xml



xml = ''
doc = Builder::XmlMarkup.new(:target => xml, :indent => 2)
doc.instruct!

doc.person(:name => 'Max', :surname => 'Mustermann') { |person|
  person.address { |address|
    address.street('Hauptstr. 42')
    address.tag!('postal-code', '12345')
    address.city('Musterstadt')
  }

  person.position(:longitude => '12.345', :latitude => '56.789')
}

puts xml



doc = Builder::XmlMarkup.new(:indent => 2)
doc.foo { |f|
  f.bar
  f.text! "I live outside the bar!\n"
}
puts doc.target!



doc = Builder::XmlMarkup.new
doc.cdata!('Do not run with scissors!')
puts doc.target!



doc = Builder::XmlMarkup.new
doc.comment!('Some comments are totally useless!')
puts doc.target!



doc = Builder::XmlMarkup.new
doc.declare!(:ENTITY, :pp, 'Pragmatic Programmers')
puts doc.target!

