#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


class FixedLengthRecordFile
  def FixedLengthRecordFile.open(filename, field_sizes)
    
    if field_sizes.nil? or field_sizes.empty?
      raise ArgumentError, "Empty field sizes not allowed!"
    end
    
    field_pattern = 'a' + field_sizes.join('a')
    IO.foreach(filename) do |line|
      record = line.chomp.unpack(field_pattern)
      record.map { |f| f.strip! }
      yield record
    end
  end
end


# vim:sw=2:tw=0
