#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'test/unit'
require 'fixfile'

class FixedLengthRecordFileTest < Test::Unit::TestCase
  def test_unknown_file
    assert_raises(Errno::ENOENT) {
      FixedLengthRecordFile.open('does_not_exist', [1])
    }
  end

  def test_illegl_field_sizes
    [nil, []].each do |illegal_size|
      assert_raises(ArgumentError) {
        FixedLengthRecordFile.open('does_not_exist', illegal_size)
      }
    end
  end

  def test_real_data
    test_data = [
      %w(1234-5678-9012-3456 Barney Gumble),
      %w(1111-2222-3333-4444 Homer Simpson)
    ]

    i = 0
    FixedLengthRecordFile.open('customers.fix', [19, 20, 30]) do |rec|
      assert_equal(test_data[i], rec)
      i += 1
    end
  end
end

# vim:sw=2:tw=0

