#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


class PropertiesFile
  def initialize(file_name)
    @properties = load_props(file_name)
  end

  def [](key) @properties[key]; end
  def to_hash() @properties; end

  private

  def load_props(file_name)
    properties = {}
    file = File.new(file_name)
    while !file.eof? do
      line = get_line(file)
      next if line =~ /^[#!]/ or line =~ /^\s*$/
      if line =~ /^\s*(\S+)\s*[=:]\s*(.*)$/
        properties[$1] = $2
      end
    end
    file.close
    properties
  end

  def get_line(file)
    current_line = file.readline.chomp
    while current_line =~ /^(.*)\\$/
      next_line = file.readline.chomp
      current_line = $1 + next_line.gsub(/^\s*(.*)$/, '\\1')
    end
    current_line
  end
end


# vim:sw=2:tw=0
