#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'propfile'
require 'test/unit'

class PropertiesFileTest < Test::Unit::TestCase
  def test_illegal_file
    assert_raises(TypeError) { PropertiesFile.new(nil) }
    assert_raises(Errno::ENOENT) { PropertiesFile.new("") }
    assert_raises(Errno::ENOENT) { PropertiesFile.new("not-existent") }
  end

  def test_only_comments
    pfile = PropertiesFile.new('comment.properties')
    properties = pfile.to_hash
    assert_equal(0, properties.size)
  end

  def test_regular_property_file
    properties = PropertiesFile.new('regular.properties')
    assert_equal('pragmatic', properties['ruby'])
    assert_equal('This value is long.', properties['broken_value'])
    assert_equal('hello', properties['colon_prop'])
    assert_equal('apple, banana, pear, cantaloupe, watermelon, kiwi, mango', properties['fruits'])
    assert_equal('example.com', properties['http.proxyHost'])
    assert_equal('8080', properties['http.proxyPort'])
  end
end

# vim:sw=2:tw=0
