#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


require 'iconv'

def empty?(text) text.nil? or text == ''; end

def encode_markup(text)
  return '' if empty?(text)
  text.gsub!('&', '&amp;')
  text.gsub!("'", '&apos;')
  text.gsub!('"', '&quot;')
  text.gsub!('<', '&lt;')
  text.gsub!('>', '&gt;')
end

def to_utf8(text)
  Iconv.conv('utf-8', 'iso-8859-1', text)
end

def encode(value)
  encode_markup(to_utf8(value))
end

def tag(tag_name, value, attrs ={})
  tmp = "<#{tag_name}"
  if !attrs.nil? and !attrs.empty?
    attrs.each { |k,v| tmp += " #{k}='#{encode(v)}'" }
  end
  if !empty?(value)
    tmp += ">#{encode(value)}</#{tag_name}>\n"
  else
    tmp += "/>\n"
  end
end


puts tag('hello', 'world & Mr. Müller')
puts tag('a', 'b', { 'c' => 'd & e' })
# vim:sw=2:tw=0
