#!/usr/local/bin/ruby -w
#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---


def encode_markup(text)
  return '' if text.nil? or text == ''
  text.gsub!('&', '&amp;')
  text.gsub!("'", '&apos;')
  text.gsub!('"', '&quot;')
  text.gsub!('<', '&lt;')
  text.gsub!('>', '&gt;')
end

def tag(tag_name, value, attrs = nil)
  tmp = "<#{tag_name}"
  if attrs
    attrs.each { |k,v| tmp += " #{k}='#{encode_markup(v)}'" }
  end
  tmp + ">#{encode_markup(value)}</#{tag_name}>\n"
end

puts tag('favorite', 'Starsky & Hutch')

# vim:sw=2:tw=0
