#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---
require 'rexml/document'
require 'rexml/validation/relaxng'
include REXML

def read_doc(filename)
  doc = IO.readlines(filename).to_s
  doc.gsub!(/\s+</, '<')
  doc.gsub!(/\s+$/, '')
  doc
end

begin
  schema = File.new('person_schema.xml')
  validator = Validation::RelaxNG.new(schema) 
  parser = Parsers::TreeParser.new(read_doc('persons.xml'))
  parser.add_listener(validator.reset)
  parser.parse 
rescue Validation::ValidationException => e
  puts "An error occurred during validation: #{e}"
rescue Exception => e
  puts "An exception occurred: #{e}"
end
