#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

class Validator
   class << self
      def validate(document, schema)
         option = case schema 
            when /\.dtd$/ then '--valid'
            when /\.xml$/ then '--relaxng'
            when /\.xsd$/ then '--schema'
         end 
         exec_xmllint(document, schema, option)
      end
   
      private
   
      def exec_xmllint(file, schema, option)
         rc = system("xmllint --noout #{option} #{schema} #{file}") 
         status = $?.exitstatus
         return true if rc && status == 0
         raise 'ValidationError' if [3, 4].include?(status)
         raise 'UnexpectedError' unless rc
      end
   end
end


if __FILE__ == $0
   
   begin
      Validator.validate('persons.xml', 'person_schema.xml')
   rescue => ex
      puts ex
   end
   
end
