#---
# Excerpted from "Enterprise Integration with Ruby"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_eir for more book information.
#---

require 'yaml'
themes = YAML::load_file('themes.yaml')
puts themes.class
puts themes.join("\n")

puts '-' * 20


include YAML
puts %w(a spectacular example).to_yaml

puts '-' * 20


[
  'PragBouquet',
  :aSymbol,
  42,
  3.14,
  true,
  { 'chunky' => 'bacon', 'answer' => 42},
].each do |obj|
  puts "#{obj.class}#to_yaml:\n#{obj.to_yaml}\n"
end

puts '-' * 20


[
  [%w(a nested list)],
  ['another', %w(more deeply), 'nested', 'list'],
  [ 'a', { 'list' => 'of', 3 => 'different' }, 'objects'],
  { 'that' => %w(is getting), 'really' => { 'very' => 'complex'}}
].each do |obj|
  puts "#{obj.inspect}.to_yaml:\n#{obj.to_yaml}\n"
end

puts '-' * 20


Flower = Struct.new(:name, :price)
[
  Time.now,
  Flower.new('rose', 1.99),
  /even regexes/i,
  'a'..'f'
].each do |obj|
  puts "#{obj.class}#to_yaml:\n#{obj.to_yaml}\n"
end



class CustomClass
  attr_accessor :a_hash, :an_array, :a_timestamp
end

custom_class = CustomClass.new
custom_class.a_hash = { 'how' => 'boring' }
custom_class.an_array = %w(still awake?)
custom_class.a_timestamp = Time.now
puts custom_class.to_yaml



p YAML::load_file('demo.yaml')

